// Copyright (c) 2021 Terminus, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package i18n

import (
	"golang.org/x/text/language"
	"golang.org/x/text/message"
)

func InitI18N() {
	message.SetString(language.SimplifiedChinese, "ImagePullFailed", "拉取镜像失败")
	message.SetString(language.SimplifiedChinese, "Unschedulable", "调度失败")
	message.SetString(language.SimplifiedChinese, "InsufficientResources", "资源不足")
	message.SetString(language.SimplifiedChinese, "ProbeFailed", "健康检查失败")
	message.SetString(language.SimplifiedChinese, "ContainerCannotRun", "容器无法启动")
}
